package com.alu.smm.ami.provisioning.consumer;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJB;

import org.jboss.ejb3.annotation.Consumer;
import org.jboss.ejb3.annotation.Pool;
import org.jboss.ejb3.annotation.defaults.PoolDefaults;

import com.alu.smm.ami.provisioning.core.AMIProvRequestDispatcher;
import com.alu.smm.ami.provisioning.producer.AMIProvRequestQueue;
import com.alu.smm.common.exception.SMMException;
import com.alu.smm.common.facade.local.SMMMessageStoreLocal;
import com.alu.smm.common.logger.SMMLogger;
import com.alu.smm.common.rt.core.RT;
import com.alu.smm.smmmessage.SMMMessage;

@Consumer(activationConfig = {
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/AMIProvRequest"),
		@ActivationConfigProperty(propertyName = "maxSession", propertyValue = RT.MAX_MDB_SESSION) })
@Pool(value = PoolDefaults.POOL_IMPLEMENTATION_STRICTMAX, maxSize = RT.POOL_SIZE, timeout = 1000)

public class AMIProvRequestMailBox implements AMIProvRequestQueue {
	private static final String JNDI_MESSAGE_STORE = "com.alu.smm.common.facade.local.SMMMessageStoreLocal";
	private static final SMMLogger LOGGER = SMMLogger.getSMMLogger(AMIProvRequestMailBox.class);
	private static final String AMIProvRequestKey = "_AMIProvRequestKey";

	@EJB
	private SMMMessageStoreLocal messageStore;
	
	@Override
	public void process(SMMMessage message) throws SMMException {
		LOGGER.info("Recieved message Inside AMIProvRequestMailBox");
		
		/*try {
		Context ctx = new InitialContext();
		SMMMessageStoreLocal messageStore = (SMMMessageStoreLocal) ctx
				.lookup(JNDI_MESSAGE_STORE);
		messageStore.storeAMIRequest(message.getInternalAMIServiceID() + AMIRequestKey, message);
		} catch (NamingException e) {
			LOGGER.error(e);
		}*/		
		messageStore.storeAMIProvRequest(message.getInternalAMIServiceId() + AMIProvRequestKey, message);
		Thread amiDispatcher = new Thread(new AMIProvRequestDispatcher(),message.getInternalAMIServiceId() + AMIProvRequestKey);
		amiDispatcher.start();
	}

}
